package com.joshvm.demo;

import org.joshvm.j2me.dio.DeviceManager;
import org.joshvm.j2me.dio.gpio.GPIOPin;
import org.joshvm.j2me.dio.gpio.GPIOPinConfig;

public class GPIODemo {

	/**
	 * 根据使用的设备设置相对应的值，
	 * 1:使用JOSH_MEGA_8300  GPIO_1=4,GPIO_2=27,GPIO_3=29,PWM/IO=25  ,现以GPIO_3=29为例
	 * 2:使用JOSH_MEGA_ESP32/ESP-LyraT-Mini
	 * 3:使用 ESP-WROVER-KIT
	 */
	private static int DEVICE_NUMBER = 1;

	private static final int JOSH_MEGA_8300_GPIO = 29;// 1.JOSH_MEGA_8300
	private static final int JOSH_MEGA_ESP32_GPIO = 22;// 2.JOSH_MEGA_ESP32/ESP-LyraT-Mini
	private static final int LEXIN_ESP32_GPIO = 2;// 3.LEXIN_ESP32

	static GPIOPinConfig cfgOutput;
	static GPIOPin outputGpio;

	public static void main(String[] args) {

		System.out.println("      ===============      Start GPIO Demo...");
		try {
			switch (DEVICE_NUMBER) {
			case 1:

				cfgOutput = new GPIOPinConfig(GPIOPinConfig.UNASSIGNED, JOSH_MEGA_8300_GPIO,
						GPIOPinConfig.DIR_OUTPUT_ONLY, GPIOPinConfig.MODE_OUTPUT_OPEN_DRAIN, GPIOPinConfig.TRIGGER_NONE,
						false);
				outputGpio = (GPIOPin) DeviceManager.open(cfgOutput, DeviceManager.EXCLUSIVE);

				break;
			case 2:
				cfgOutput = new GPIOPinConfig(GPIOPinConfig.UNASSIGNED, JOSH_MEGA_ESP32_GPIO,
						GPIOPinConfig.DIR_OUTPUT_ONLY, GPIOPinConfig.MODE_OUTPUT_PUSH_PULL, GPIOPinConfig.TRIGGER_NONE,
						false);
				outputGpio = (GPIOPin) DeviceManager.open(cfgOutput, DeviceManager.EXCLUSIVE);

				break;
			case 3:

				cfgOutput = new GPIOPinConfig(GPIOPinConfig.UNASSIGNED, LEXIN_ESP32_GPIO, GPIOPinConfig.DIR_OUTPUT_ONLY,
						GPIOPinConfig.MODE_OUTPUT_OPEN_DRAIN, GPIOPinConfig.TRIGGER_NONE, false);
				outputGpio = (GPIOPin) DeviceManager.open(cfgOutput, DeviceManager.EXCLUSIVE);

				break;

			default:
				break;
			}

			while (true) {
				Thread.sleep(1000);
				outputGpio.setValue(true);
				Thread.sleep(1000);
				outputGpio.setValue(false);
			}

		} catch (Exception e) {
			e.printStackTrace();
		}

	}
}
